
#ifndef __FTPCLIENTAPP_H_
#define __FTPCLIENTAPP_H_

#include <omnetpp.h>
#include "TCPGenericCliAppBase.h"

#define WIN_TIME_SIZE 5
#define WIN_DELTA 1
#define TAB_SIZE (WIN_TIME_SIZE/WIN_DELTA)

/**
 * An example request-reply based client application.
 */
class INET_API FTPClientApp : public TCPGenericCliAppBase
{
  protected:
    cMessage *timeoutMsg;
	bool serverClose; // 
    bool earlySend;  // if true, don't wait with sendRequest() until established()
	double lastRecvdMsg;

	unsigned int intervalSize, totalSize;
	unsigned int tabIndex;
	unsigned int _intervalSizes[(int)TAB_SIZE];

	cOutVector receivedRate;

    /** Utility: sends a request to the server */
    void sendRequest();

  public:
    FTPClientApp();
    virtual ~FTPClientApp();

  protected:
    /** Redefined to schedule a connect(). */
    virtual void initialize();

    /** Redefined. */
    virtual void handleTimer(cMessage *msg);

    /** Redefined. */
    virtual void socketEstablished(int connId, void *yourPtr);

    /** Redefined. */
    virtual void socketDataArrived(int connId, void *yourPtr, cMessage *msg, bool urgent);

    /** Redefined to start another session after a delay. */
    virtual void socketClosed(int connId, void *yourPtr);

    /** Redefined to reconnect after a delay. */
    virtual void socketFailure(int connId, void *yourPtr, int code);

    /** Record the received rate in the Omnetpp.vec file. */
	virtual void recordReceivedRate(cMessage *msg);
};

#endif


