//
// Copyright 2004 Andras Varga
//
// This library is free software, you can redistribute it and/or modify
// it under  the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation;
// either version 2 of the License, or any later version.
// The library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU Lesser General Public License for more details.
//

#ifndef __TCPBASICCLIENTAPP_H_
#define __TCPBASICCLIENTAPP_H_

#include <omnetpp.h>
#include "TCPGenericCliAppBase.h"

#define WIN_TIME_SIZE 2
#define WIN_DELTA 0.4
#define TAB_SIZE (WIN_TIME_SIZE/WIN_DELTA)

/**
 * An example request-reply based client application.
 */
class INET_API TCPBasicClientApp : public TCPGenericCliAppBase
{
  protected:
    cMessage *timeoutMsg;
    bool earlySend;  // if true, don't wait with sendRequest() until established()
    int numRequestsToSend; // requests to send in this session
	double timeStampLastMessageReceived; // time  stamp of last received message

	unsigned int intervalSize, totalSize;
	unsigned int tabIndex;
	unsigned int _intervalSizes[(int)TAB_SIZE];

	cOutVector receivedRate;

    /** Utility: sends a request to the server */
    void sendRequest();

  public:
    TCPBasicClientApp();
    virtual ~TCPBasicClientApp();

  protected:
    /** Redefined to schedule a connect(). */
    virtual void initialize();

    /** Redefined. */
    virtual void handleTimer(cMessage *msg);

    /** Redefined. */
    virtual void socketEstablished(int connId, void *yourPtr);

    /** Redefined. */
    virtual void socketDataArrived(int connId, void *yourPtr, cMessage *msg, bool urgent);

    /** Redefined to start another session after a delay. */
    virtual void socketClosed(int connId, void *yourPtr);

    /** Redefined to reconnect after a delay. */
    virtual void socketFailure(int connId, void *yourPtr, int code);

    /** Record the received rate in the Omnetpp.vec file. */
	virtual void recordReceivedRate(cMessage *msg);
};

#endif


