//
// Copyright (c) 2007 INRIA
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// @author Ahmed Ayadi < Ahmed.Ayadi@sophia.inria.fr>
// @date 2008-01-11
//

#ifndef __RTPAVProfilePayload100Receiver_H__
#define __RTPAVProfilePayload100Receiver_H__

#include <omnetpp.h>

#include "RTPPayloadReceiver.h"
#include "RTPInnerPacket.h"
#include "RTPPacket.h"

/**
 * This module is used to receive data (mpeg video) of payload 100 for rtp
 * endsystems working under the rtp av profile.
 */
class INET_API RTPAVProfilePayload100Receiver : public RTPPayloadReceiver
{
    protected:
      /**
       * Destructor.
       */

      virtual ~RTPAVProfilePayload100Receiver();

      /**
       * Calls the method of the superclass RTPPayloadReceiver and sets the
       * payload type to 100.
       */
      virtual void initialize();

	  virtual void finish();


    protected:

        /**
         * A reordering queue for incoming packets.
         */
        cQueue *_queue;

        /**
         * Stores the lowest allowed time stamp of rtp data packets. The value
         * is used to throw away packets from mpeg frames already stored in
         * the data file.
         */
        double _lowestAllowedTimeStamp;
        int  _lostPacketNumber;
        int  _highestSequenceNumber;
        int  _lowestSequenceNumber;


        /**
         * Writes information about received frames into the output file.
         * The only error correction provided is reordering packets
         * of one frame if needed.
         */
        virtual void processPacket(RTPPacket *packet);

        /**
         * Rate of video tranmission
         */
		cOutVector _rate;

	int serveur ;
	int NBpaquet;
	int srcaddr;
	int myaddr;
	FILE *fpClient;
	int compte;

	double lastrcvd;
	cOutVector rcvdThruput;
};

#endif
