//
// Copyright (c) 2007 INRIA
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// @author Ahmed Ayadi < Ahmed.Ayadi@sophia.inria.fr>
// @date 2008-01-11
//
 
#ifndef __RTPAVProfilePayload100Sender_H__
#define __RTPAVProfilePayload100Sender_H__

#include <omnetpp.h>
#include "RTPPayloadSender.h"

/**
 * An RTPAVProfilePayload10Sender is a module for sending data of payload
 * type 100
 * The corresponding receiver module RTPAVProfilePayload100Receiver.
 */
class INET_API RTPAVProfilePayload100Sender : public RTPPayloadSender
{

  protected:

    /**
     * Initializes the module. It sets the values for clock rate and payload type.
     */
    virtual void initialize();

    /**
     * The main method.
     */
    //virtual void activity();

	int TestEndFile(RTPAVProfilePayload100Sender *pt,int fin);
	int Strcmp(char mot[4],char label[4]);
	virtual void finish();

    protected:

        /**
         * This method reads the gdf file header.
         */
        virtual void initializeSenderModule(RTPInnerPacket *rinpIn);

        /**
         * This method sends one mpeg frame. It sends one or more
         * rtp data packet. Returns false if there were no more frames.
         */
        virtual bool sendPacket();

        /**
         * The initial delay of the mpeg video.
         */
        double _initialDelay;

        /**
         * The number of frames per second of the mpeg video.
         */
        double _framesPerSecond;

        /**
         * The number of the current mpeg frame. Needed for calculating
         * the rtp time stamp in the rtp data packets.
         */
        double _frameNumber;

        /**
         * Rate of video tranmission
         */
		cOutVector _rate;

		int  serveur;
		char label[4];
		char mot[4];
		int  offset;
		int  offdeb;
		int  offfin;
		int  size;
		int  fin;
		int comptesize;

		FILE *fpServeur;


};

#endif
