//
// Copyright (c) 2007 INRIA
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// @author Ahmed Ayadi < Ahmed.Ayadi@sophia.inria.fr>
// @date 2008-01-11
//

#ifndef __RTP_MPEG_WITH_PAYLOAD_PACKET_H__
#define __RTP_MPEG_WITH_PAYLOAD_PACKET_H__

#include <omnetpp.h>
#include "INETDefs.h"
#include "RTPMpegPacket.h"

class INET_API RTPMpegWithPayloadPacket : public cPacket
{

    public:
    /**
     * Default constructor.
     */
	RTPMpegWithPayloadPacket(const char *name = NULL);
	
	/**
    * Destructor.
    */
    virtual ~RTPMpegWithPayloadPacket();

        /**
         * Returns the constant header length (4 bytes).
         */
        static int headerLength();

        /**
         * Returns the size of mpeg data.
         */
        virtual int payloadLength();

	void setDataArraySize(unsigned int size);
    unsigned int getDataArraySize() const;

	char getData(unsigned int k) const;
    void setData(unsigned int k, char data_var);

	// payload
	char *data_var; 
    unsigned int data_arraysize;

};

#endif
