/***************************************************************************
                          types.h  -  description
                             -------------------
    begin                : Fri Dec 14 2001
    copyright            : (C) 2001 by Matthias Oppitz
    email                : Matthias.Oppitz@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <sys/types.h>

/** \file types.h
 * This file declares some integer types needed for rtp.
 */

/**
 * An unsigned 8 bit integer.
 */
typedef unsigned char  u_int8;
typedef unsigned char  u8;

/**
 * An unsigned 16 bit integer.
 */
typedef unsigned short u_int16;
typedef unsigned short u16;

/**
 * An unsigned 32 bit integer.
 */
typedef unsigned int u_int32;
//typedef unsigned int u32;

/**
 * A signed 16 bit integer.
 */
typedef short int16;

/**
 * A signed 32 bit integer.
 */
typedef signed int int32;


/**
 * An unsigned 64 bit integer.
 */
typedef unsigned long long u_int64;
typedef unsigned long long u64;

#define RTP_VERSION 2
#define RTP_SEQ_MOD (1<<16)
#define RTP_MAX_SDES 255 /* maximum text length for SDES */

#define RTCP_VALID_MASK (0xc000 | 0x2000 | 0xfe)
#define RTCP_VALID_VALUE ((RTP_VERSION << 14) | RTCP_SR)